## govarnam 1.9.0

=== Makefile ===
.DEFAULT_GOAL := build

.PHONY:default
default: build ;

CLI_BIN := varnamcli
INSTALL_PREFIX := $(or ${PREFIX},${PREFIX},/usr/local)

# Try to get the commit hash from git
LAST_COMMIT := $(or $(shell git rev-parse --short HEAD 2> /dev/null),"UNKNOWN")
VERSION := $(or $(shell echo $$(git describe --abbrev=0 --tags || echo "latest") | sed s/v//),"v0.0.0")
BUILDSTR := ${VERSION} (\#${LAST_COMMIT} $(shell date -u +"%Y-%m-%dT%H:%M:%S%z"))

RELEASE_NAME := govarnam-${VERSION}-${shell uname -m}
UNAME := $(shell uname)

SED := sed -i
LIB_NAME := libgovarnam.so

ifeq ($(UNAME), Darwin)
  SED := sed -i ""
	LIB_NAME = libgovarnam.dylib
endif

VERSION_STAMP_LDFLAGS := -X 'github.com/varnamproject/govarnam/govarnam.BuildString=${BUILDSTR}' -X 'github.com/varnamproject/govarnam/govarnam.VersionString=${VERSION}'

pc:
	cp govarnam.pc.in govarnam.pc
	${SED} "s#@INSTALL_PREFIX@#${INSTALL_PREFIX}#g" govarnam.pc
	${SED} "s#@VERSION@#${VERSION}#g" govarnam.pc

# Used only for building the CLI
temp-pc:
	cp govarnam.pc.in govarnam.pc
	${SED} "s#@INSTALL_PREFIX@#$(realpath .)#g" govarnam.pc
	${SED} "s#@VERSION@#${VERSION}#g" govarnam.pc

	${SED} "s#/include/libgovarnam##g" govarnam.pc
	${SED} "s#/lib##g" govarnam.pc

install-script:
	cp install.sh.in install.sh
	${SED} "s#@INSTALL_PREFIX@#${INSTALL_PREFIX}#g" install.sh
	${SED} "s#@VERSION@#${VERSION}#g" install.sh
	${SED} "s#@LIB_NAME@#${LIB_NAME}#g" install.sh
	chmod +x install.sh

install:
	./install.sh install

.PHONY: cli
cli:
	go build -o ${CLI_BIN} -ldflags "-s -w" ./cli

library-nosqlite:
	CGO_ENABLED=1 go build -tags "fts5,libsqlite3" -buildmode=c-shared -ldflags "-s -w ${VERSION_STAMP_LDFLAGS}" -o ${LIB_NAME} .

library:
	CGO_ENABLED=1 go build -tags "fts5" -buildmode=c-shared -ldflags "-s -w ${VERSION_STAMP_LDFLAGS}" -o ${LIB_NAME} .

library-mac-universal:
	GOOS=darwin GOARCH=arm64 $(MAKE) library
	mv ${LIB_NAME} ${LIB_NAME}.arm64
	GOOS=darwin GOARCH=amd64 $(MAKE) library
	mv ${LIB_NAME} ${LIB_NAME}.amd64
	lipo -create -output ${LIB_NAME} ${LIB_NAME}.arm64 ${LIB_NAME}.amd64

.PHONY: nix
nix:
	$(MAKE) library

	$(MAKE) temp-pc
	PKG_CONFIG_PATH=$(realpath .):$$PKG_CONFIG_PATH $(MAKE) cli

	$(MAKE) pc
	$(MAKE) install-script

.PHONY:
build:
	$(MAKE) nix

release:
	echo "Hope you have updated version in constants.go"
	mkdir -p ${RELEASE_NAME}
	cp ${CLI_BIN} ${RELEASE_NAME}/
	cp libgovarnam.so ${RELEASE_NAME}/
	cp *.h ${RELEASE_NAME}/
	cp *.pc ${RELEASE_NAME}/
	cp install.sh ${RELEASE_NAME}/

	zip -r ${RELEASE_NAME}.zip ${RELEASE_NAME}/*

test-govarnamgo:
	$(MAKE) temp-pc
	PKG_CONFIG_PATH=$(realpath .):$$PKG_CONFIG_PATH LD_LIBRARY_PATH=$(realpath .):$$LD_LIBRARY_PATH govarnamgo/run_tests.sh

test:
	go test -tags fts5 -count=1 -cover govarnam/*.go

	$(MAKE) library
	$(MAKE) test-govarnamgo

=== debian/changelog ===
govarnam (1.9.0-2build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 16:49:30 +0200

govarnam (1.9.0-2) unstable; urgency=medium

  * d/control: Recommend individual scheme files too.
    This allows users to select a specific one if they don't want the whole
    set.

 -- Guido Günther <agx@sigxcpu.org>  Fri, 03 Nov 2023 11:31:07 +0100

govarnam (1.9.0-1) unstable; urgency=medium

  * Initial Debian release (Closes: #1052001)

 -- Guido Günther <agx@sigxcpu.org>  Sat, 23 Sep 2023 16:51:57 +0200

=== debian/control ===
Source: govarnam
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
Uploaders: Guido Günther <agx@sigxcpu.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-golang,
 fakeroot,
 golang-any (>= 1.16.0),
 golang-github-mattn-go-sqlite3-dev,
 pkg-config,
Standards-Version: 4.6.2
Homepage: https://github.com/varnamproject/govarnam
Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/govarnam
Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/govarnam.git
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/varnamproject/govarnam

Package: libgovarnam1
Architecture: any
Multi-Arch: same
Section: libs
Recommends:
 varnam-schemes | varnam-schemes-ml | varnam-schemes-ta | varnam-schemes-hi,
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Built-Using: ${misc:Built-Using}
Description: Transliteration library to type Indic languages
 Govarnam is a transliteration library to type Indic languages.
 .
 This package contains the shared libraries for applications interfacing with
 govarnam.

Package: libgovarnam-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libgovarnam1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Built-Using: ${misc:Built-Using}
Description: Development files for libgovarnam
 Govarnam is a transliteration library to type Indic languages.
 .
 This package contains development files and Vala bindings to use when writing
 applications that interface with GThd.

=== debian/tests/control ===
Tests: build-test
Depends:
 build-essential,
 libgovarnam-dev,
 pkg-config,
Restrictions: allow-stderr, superficial

## govarnam 1.9.1

=== Makefile ===
--- 
+++ 
@@ -16,14 +16,17 @@
 
 SED := sed -i
 LIB_NAME := libgovarnam.so
+SO_NAME := $(shell (echo $(VERSION) | cut -d. -f1))
+CURDIR := $(shell pwd)
 
 ifeq ($(UNAME), Darwin)
   SED := sed -i ""
-	LIB_NAME = libgovarnam.dylib
+  LIB_NAME = libgovarnam.dylib
+else
+  EXT_LDFLAGS = -extldflags "-Wl,-soname,$(LIB_NAME).$(SO_NAME),--version-script,$(CURDIR)/govarnam.syms"
 endif
 
-VERSION_STAMP_LDFLAGS := -X 'github.com/varnamproject/govarnam/govarnam.BuildString=${BUILDSTR}' -X 'github.com/varnamproject/govarnam/govarnam.VersionString=${VERSION}'
-
+VERSION_STAMP_LDFLAGS := -X 'github.com/varnamproject/govarnam/govarnam.BuildString=${BUILDSTR}' -X 'github.com/varnamproject/govarnam/govarnam.VersionString=${VERSION}' $(EXT_LDFLAGS)
 pc:
 	cp govarnam.pc.in govarnam.pc
 	${SED} "s#@INSTALL_PREFIX@#${INSTALL_PREFIX}#g" govarnam.pc
@@ -36,17 +39,25 @@
 	${SED} "s#@VERSION@#${VERSION}#g" govarnam.pc
 
 	${SED} "s#/include/libgovarnam##g" govarnam.pc
-	${SED} "s#/lib##g" govarnam.pc
+	${SED} "s#/lib\$$##g" govarnam.pc
 
-install-script:
+install.sh: install.sh.in
 	cp install.sh.in install.sh
 	${SED} "s#@INSTALL_PREFIX@#${INSTALL_PREFIX}#g" install.sh
 	${SED} "s#@VERSION@#${VERSION}#g" install.sh
 	${SED} "s#@LIB_NAME@#${LIB_NAME}#g" install.sh
+	${SED} "s#@SO_NAME@#${SO_NAME}#g" install.sh
 	chmod +x install.sh
 
-install:
+.PHONY: install
+install: install.sh
 	./install.sh install
+
+.PHONY: uninstall
+uninstall: install.sh
+	./install.sh uninstall
+
+
 
 .PHONY: cli
 cli:
@@ -57,6 +68,7 @@
 
 library:
 	CGO_ENABLED=1 go build -tags "fts5" -buildmode=c-shared -ldflags "-s -w ${VERSION_STAMP_LDFLAGS}" -o ${LIB_NAME} .
+	ln -sf "$(realpath ./)/libgovarnam.so" "$(realpath ./)/libgovarnam.so.${SO_NAME}"
 
 library-mac-universal:
 	GOOS=darwin GOARCH=arm64 $(MAKE) library
@@ -73,7 +85,7 @@
 	PKG_CONFIG_PATH=$(realpath .):$$PKG_CONFIG_PATH $(MAKE) cli
 
 	$(MAKE) pc
-	$(MAKE) install-script
+	$(MAKE) install.sh
 
 .PHONY:
 build:
@@ -83,7 +95,7 @@
 	echo "Hope you have updated version in constants.go"
 	mkdir -p ${RELEASE_NAME}
 	cp ${CLI_BIN} ${RELEASE_NAME}/
-	cp libgovarnam.so ${RELEASE_NAME}/
+	cp libgovarnam.so* ${RELEASE_NAME}/
 	cp *.h ${RELEASE_NAME}/
 	cp *.pc ${RELEASE_NAME}/
 	cp install.sh ${RELEASE_NAME}/
@@ -99,3 +111,7 @@
 
 	$(MAKE) library
 	$(MAKE) test-govarnamgo
+
+.PHONY: clean
+clean:
+	rm -f varnamcli libgovarnam.*  govarnam.pc install.sh

=== debian/changelog ===
govarnam (1.9.1-1) unstable; urgency=medium

  * New upstream release
  * Rediff patches.
    We can drop most of them only keeping the ones that allow one to set
    libdir and to skip cli installation.
  * d/rules: Adjust to install.sh target rename
  * install: Allow for minor version updates
  * Use generated symlink.
    The symlink with the soname is now handled by the upstream
    scripts
  * install: Use symlink without path
  * Use pkgconf instead of pkg-config
  * Bump standards version. No changes needed.
  * Add gitignore
  * Add new symbols.
    They're not namespaced atm:
        https://github.com/varnamproject/govarnam/issues/65
  * Drop `bool` typedef.
    Use `int` instead which it was aliased too.
    Closes: #1096754

 -- Guido Günther <agx@sigxcpu.org>  Sat, 06 Sep 2025 14:57:58 +0200

=== debian/control ===
Source: govarnam
Section: x11
Priority: optional
Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
Uploaders:
 Guido Günther <agx@sigxcpu.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-golang,
 fakeroot,
 golang-any (>= 1.16.0),
 golang-github-mattn-go-sqlite3-dev,
 pkgconf,
Standards-Version: 4.7.0
Homepage: https://github.com/varnamproject/govarnam
Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/govarnam
Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/govarnam.git
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/varnamproject/govarnam

Package: libgovarnam1
Architecture: any
Multi-Arch: same
Section: libs
Recommends:
 varnam-schemes | varnam-schemes-ml | varnam-schemes-ta | varnam-schemes-hi,
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Built-Using:
 ${misc:Built-Using},
Description: Transliteration library to type Indic languages
 Govarnam is a transliteration library to type Indic languages.
 .
 This package contains the shared libraries for applications interfacing with
 govarnam.

Package: libgovarnam-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libgovarnam1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Built-Using:
 ${misc:Built-Using},
Description: Development files for libgovarnam
 Govarnam is a transliteration library to type Indic languages.
 .
 This package contains development files and Vala bindings to use when writing
 applications that interface with GThd.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export GO111MODULE=off
export GOPROXY=off
export GOCACHE=$(CURDIR)/_build/go-build
export GOPATH=$(CURDIR)/_build
export DH_GOLANG_INSTALL_EXTRA := govarnam/migrations/ install.sh.in govarnam.syms

export DESTDIR=debian/tmp
export PREFIX=/usr

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

override_dh_auto_build:
	make LIBDIR=/lib/$(DEB_HOST_MULTIARCH) VERSION=$(DEB_VERSION_UPSTREAM) library install.sh pc

override_dh_auto_install:
	SUDO=fakeroot make install

override_dh_auto_test:
	# TODO: run tests once we have the VST files in Debian

=== debian/tests/control ===
Tests:
 build-test,
Depends:
 build-essential,
 libgovarnam-dev,
 pkg-config,
Restrictions:
 allow-stderr,
 superficial,

=== debian/watch ===
 version=4
 opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
             https://github.com/varnamproject/govarnam/tags \
             (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
